﻿; ASCII TILESET EXTRACTOR ALGORITHM By SERGIO 'ManOwaR' SOEIRO 2017
; 
; * OK! So you have a nice ASCII TILESET! 16x16 tiles...and now what?
;   This simple algorithm extracts a tile from the tileset.
;   The tile to extract must be a number between 0-255
;   Since characters also have a ascii code nummber, it easy to understand that
;    an "A" corresponds to tile 65 etc... so you can use strings to extract
;    characters from the tileset representing the same ascii char.
;  * Here i'm using pre-defined values for font size (wich will be displayed with a
;     resolution of 24x24 so it could be changed for any other value or a var
;  FONT is JOLLY and has been taken from http://dwarffortresswiki.org/images/4/4d/Jolly12x12.png
;  AUTHOR: Alexander osias
;
;  HOPE THIS IS USEFUL TO SOMEBODY
;
;
; EMAIL:sergiomanowarsoeiro@gmail.com
; Greetings for people at dbfinteractive.com 

InitSprite()
InitMouse()
InitKeyboard()

UsePNGImageDecoder()
OpenScreen(640,480,32,"TILESET EXTRACTOR",#PB_Screen_SmartSynchronization,60)
LoadSprite(1,"DATA/TILESETS/Jolly12x12.png")


; TILESET
Global tileset_rows=16:;It's an ascii tileset so it is a squared 16x16 tileset. Any other type of tileset will require changes.
Global tile_width=12,tile_height=12,tile_x1,tile_y1,tile




LOOP: 
; DRAW
FlipBuffers()
ClearScreen(0)
ClipSprite(1,-1,-1,-1,-1)
DisplaySprite(1,0,20)
; EXTRACT TILE
For byte=1 To Len(FullText$)
  tile=Asc(Mid(fulltext$,byte,1))
  tile_y1=Int(tile/tileset_rows)*tile_height
  tile_x1=Mod(tile,tileset_rows)*tile_width
  ClipSprite(1,-1,-1,-1,-1)
  ClipSprite(1,tile_x1,tile_y1,tile_width,tile_height)
  ZoomSprite(1,24,24)
  DisplaySprite(1,byte*24-24,300)
  DisplaySprite(1,320-Len(fulltext$)*24/2+byte*24-24,350)
  DisplaySprite(1,640-Len(fulltext$)*24+byte*24-24,400)
Next
StartDrawing(ScreenOutput())
If FullText$<>""
  DrawText(300,280,"LEFT ALIGNEMENT")
  DrawText(300,330,"CENTERED ALIGNEMENT")
  DrawText(300,380,"RIGHT ALIGNEMENT")
EndIf
DrawText(0,0,"Press [ESC] to exit...")
DrawText(0,460,"/¡\ TYPE SOME WORDS...")
StopDrawing()
; INPUTS
ExamineKeyboard()
; >>> THIS PART TAKEN FROM THE PUREBASIC HELP FILES
If KeyboardReleased(#PB_Key_Back)
  FullText$ = Left(FullText$, Len(FullText$)-1)
Else
  result$=KeyboardInkey()
  If FindString("1234567890 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz", result$) ; Or your chosen valid characters
    If Len(fulltext$)<25:FullText$ + result$:EndIf
  EndIf ; Add the new text to the current one (if any)
EndIf
; <<< THIS PART TAKEN FROM THE PUREBASIC HELP FILES
If KeyboardPushed(#PB_Key_Escape):End:EndIf
Goto LOOP

; IDE Options = PureBasic 5.60 (Windows - x64)
; CursorPosition = 22
; FirstLine = 11
; EnableXP